#
# Copyright (C) 2021 Associated Universities, Inc. Washington DC, USA.
#
# This file is part of NRAO Workspaces.
#
# Workspaces is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Workspaces is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Workspaces.  If not, see <https://www.gnu.org/licenses/>.
from workspaces.capability.helpers import (AwaitQa, AwaitWorkflow,
                                           CapabilityStep,
                                           PrepareAndRunWorkflow)


def test_parse_workflow():
    """
    Tests that CapabilityStep parsing works as intended
    """
    step = CapabilityStep.from_str("prepare-and-run-workflow foo [bar]")
    assert isinstance(step, PrepareAndRunWorkflow)
    step = CapabilityStep.from_str("await-qa foo [bar]")
    assert isinstance(step, AwaitQa)
    step = CapabilityStep.from_str("await-workflow foo [bar]")
    assert isinstance(step, AwaitWorkflow)
