#
# Copyright (C) 2021 Associated Universities, Inc. Washington DC, USA.
#
# This file is part of NRAO Workspaces.
#
# Workspaces is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Workspaces is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Workspaces.  If not, see <https://www.gnu.org/licenses/>.
from __future__ import annotations

from typing import Dict, List

from workspaces.system.schema import JSONSerializable


class WorkflowRequestFileIF(JSONSerializable):
    filename: str
    content: bytes


class WorkflowTemplateIF(JSONSerializable):
    filename: str
    content: bytes


class WorkflowIF(JSONSerializable):
    workflow_name: str
    uses_casa: bool
    templates: List[WorkflowTemplateIF]
    requests: List[WorkflowRequestIF]

    def render_templates(self, argument: Dict) -> List[WorkflowRequestFileIF]:
        pass


class WorkflowRequestIF(JSONSerializable):
    workflow_request_id: int
    workflow: WorkflowIF
    workflow_name: str
    argument: str  # JSON-formatted
    state: str
    results_dir: str
    files: List[WorkflowRequestFileIF]
    job_id: str
